/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata;

import org.eclipse.sensinact.model.core.provider.Provider;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Test Sensor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.TestSensor#getTemp <em>Temp</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.TestSensor#getTempNonContaint <em>Temp Non Containt</em>}</li>
 * </ul>
 *
 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestSensor()
 * @model
 * @generated
 */
@ProviderType
public interface TestSensor extends Provider {
	/**
	 * Returns the value of the '<em><b>Temp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Temp</em>' containment reference.
	 * @see #setTemp(TestTemperatur)
	 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestSensor_Temp()
	 * @model containment="true"
	 * @generated
	 */
	TestTemperatur getTemp();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.testdata.TestSensor#getTemp <em>Temp</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Temp</em>' containment reference.
	 * @see #getTemp()
	 * @generated
	 */
	void setTemp(TestTemperatur value);

	/**
	 * Returns the value of the '<em><b>Temp Non Containt</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Temp Non Containt</em>' reference.
	 * @see #setTempNonContaint(TestTemperatur)
	 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestSensor_TempNonContaint()
	 * @model
	 * @generated
	 */
	TestTemperatur getTempNonContaint();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.testdata.TestSensor#getTempNonContaint <em>Temp Non Containt</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Temp Non Containt</em>' reference.
	 * @see #getTempNonContaint()
	 * @generated
	 */
	void setTempNonContaint(TestTemperatur value);

} // TestSensor
